package func2graphrenewed;

import javax.swing.JOptionPane;

import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.internal.core.SourceMethod;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.ISelectionListener;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.part.ViewPart;

@SuppressWarnings("restriction")
public class Func2GraphView extends ViewPart {

	/**********************************************************
	 *                       VARIABLES                        *
	 **********************************************************/
	private Function aFunction;
	private Tree aTree;
	GraphCanvas grc;
	
	private ISelectionListener myListener =  new ISelectionListener() {
		public void selectionChanged(IWorkbenchPart part, ISelection selection) {
			if(selection instanceof IStructuredSelection)
			{
				IStructuredSelection structSel= (IStructuredSelection)selection;
				if(structSel.getFirstElement() instanceof SourceMethod) {
					String method;
					
					try {
						SourceMethod sourceMethod = (SourceMethod)structSel.getFirstElement();
						method = sourceMethod.getSource();
						String  methodName = sourceMethod.getElementName();
						setFunction(method, methodName);
					} 
					
					catch (JavaModelException e) {
						JOptionPane.showMessageDialog(null, "Cannot Get Source");
						
					}
				}
				
			}	
		}
	};
	

	
	
	/**********************************************************
	 *                     Constructor                        *
	 **********************************************************/
	public Func2GraphView() {
		
	}

	/**********************************************************
	 *                      FUNCTIONS                         *
	 **********************************************************/
	
/* ******************************************************** */
	public void setFunction(String method, String methodName){
/* ******************************************************** */
		this.setPartName(methodName);
		aFunction = new Function(method, methodName);
		aTree = new Tree(aFunction, 5, 7); // num1 => node height num2s=> space btw nodes
		aTree.setPosition();
		grc.firstDraw(aTree);
	}
	

	/**********************************************************
	 *                 INHERITED FUNCTIONS                    *
	 **********************************************************/
	@Override
	public void createPartControl(Composite parent) {
		getSite().getWorkbenchWindow().getSelectionService().addSelectionListener(myListener);
		grc = new GraphCanvas(parent);
	}

	@Override
	public void setFocus() {
		grc.setFocus();

	}
	
	public void dispose() {
		getSite().getWorkbenchWindow().getSelectionService().removeSelectionListener(myListener);
		grc.dispose();
		super.dispose();
	}

}
