package func2graphrenewed;

import java.util.ArrayList;
import java.util.TreeMap;

public class Function {
	
	/**********************************************************
	 *                       VARIABLES                        *
	 **********************************************************/
	private String initial, newFunction, name;
	private ArrayList<String> allCodes;
	
	/**********************************************************
	 *                     Constructor                        *
	 **********************************************************/
	public Function(String initial, String name){
		this.initial = initial;
		this.name = name;
		allCodes= new ArrayList<>();
		remake(this.initial);
	}
	
	
	/**********************************************************
	 *                      FUNCTIONS                         *
	 **********************************************************/
	
	
/* ******************************************************** */
	public void remake(String initial){
/* ******************************************************** */
		newFunction = removeTitle(initial);
		buildList(newFunction);
		
		newFunction = newFunction.replaceAll("\\/\\/.*", ""); // Erase inline comments
		newFunction = newFunction.replaceAll("(?s)\\s*/\\*.*?\\*/", ""); // Erase multiline comments
		newFunction = newFunction.replaceAll("(#|@|$|~)","");// just in case - it'll be used later
		newFunction = newFunction.replaceAll("(case |default ?)(.*?:)", "&case@~"); //Need to take care of case before removing spaces
		//newFunction = newFunction.replaceAll("([^a-zA-Z0-9_-])else +if ?([^a-zA-Z0-9_-])","$1else()if$2");
		newFunction = newFunction.replaceAll("([^a-zA-Z0-9_-])else +if ?([^a-zA-Z0-9_-])","$1mixed$2");
		//newFunction = newFunction.replaceAll("([^a-zA-Z0-9_-])else +if ?([^a-zA-Z0-9_-])","$1#$2");
		newFunction = newFunction.replaceAll("[^a-zA-Z0-9_-]else[^a-zA-Z0-9\\(_-]","else()");
		newFunction = newFunction.replaceAll("(\t|\n|\r| )+", ""); // Put (only one) NO space instead of whitespaces
		newFunction = newFunction.replaceAll("(\".*?\")", ""); // Erase strings
		newFunction = newFunction.replaceAll("(\'.*?\')", ""); // Erase chars
		//newFunction = newFunction.replaceAll("elseif\\(.*?\\)", "else()"); // Replace else if by else to avoid confusion with if itself
		newFunction = newFunction.replaceAll("else(\\{)", "else()$1"); // Replace else{ with else(){
		newFunction= emptyRoundBrackets(newFunction);
		newFunction = newFunction.replaceAll("(\\().*?(\\))", "$1$2"); // Erase what's between () to avoid possible confusion
		newFunction = newFunction.replaceAll("([a-zA-Z0-9_-])(if|for|else|switch|case|while|try|catch|mixed)","var"); // Erase words like onwhile
		newFunction = newFunction.replaceAll("(if|for|else|switch|case|while|try|catch|mixed)([a-zA-Z0-9_-])","var"); // Erase words like forinstance
		
		newFunction = newFunction.replaceAll("(catch)\\(\\)", "$1"); // Replace catch() by catch to avoid taking it for a condition
		newFunction = newFunction.replaceAll("try", "try\\$"); 
		newFunction = newFunction.replaceAll("catch", "catch\\$"); 
		newFunction = newFunction.replaceAll("[0-9]",""); //Remove numbers for when replacing { and } by numbers
		
		newFunction = newFunction.replaceAll("(switch)(.*?)(&case@~)", "$1$2case@~"); //Erase the & from the first case.
		newFunction = closeCases(newFunction);
		newFunction = newFunction.replaceAll("~", "\\{");
		newFunction = newFunction.replaceAll("&", "\\}");
		while(newFunction != newFunction.replaceAll("(if|for|else|switch|while|mixed)\\(\\)","$1@"))//Replace () of condition with @
				newFunction = newFunction.replaceAll("(if|for|else|switch|while|mixed)\\(\\)","$1@"); 
		newFunction = placeBrackets(newFunction);
		newFunction = arrangeElseIf(newFunction);
		newFunction = newFunction.replaceAll("mixed", "else@{if");
		newFunction = replaceBrackets(newFunction);
		newFunction = newFunction.replaceAll("[^(\\$|@)]([0-9]+)#[^0-9]*\\1~",""); // replace int[]={,,,} by int[]=
		while(newFunction != newFunction.replaceAll("(\\$)([0-9]+)#(.*)([^0-9])\\2~","$1$3$4")) // erase try$11# 11~ same with catch
			newFunction = newFunction.replaceAll("(\\$)([0-9]+)#(.*)([^0-9])\\2~","$1$3$4");
		newFunction = newFunction.replaceAll(";", ";\n");
		newFunction = newFunction.replaceAll("#", "#\n");
		newFunction = newFunction.replaceAll("~", "~\n");
		
	}
	
	
/* ******************************************************** */
	public void buildList(String aFunction){
/* ******************************************************** */
		char[] arrF = aFunction.toCharArray();
		char flagStrComm='\0';
		allCodes.add(0, aFunction);
		int id=1;

		for(int i=0; i<arrF.length;i++){
			
			if(flagStrComm=='\0'){
				
				if(arrF[i] == '\'' || arrF[i] == '\"') 
					flagStrComm = arrF[i];
				
				else if	(((i+1)< arrF.length && arrF[i] == '\\' && arrF[i+1]== '*') || ((i+1)< arrF.length && arrF[i] == '\\' && arrF[i+1]== '\\') )
				{	
					flagStrComm = arrF[i+1];
					i++;
				}
				
				else{
					if((i+2)<arrF.length && arrF[i]=='f' && arrF[i+1]=='o' && arrF[i+2]=='r'){
						if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(arrF[i-1]))) 
								&& ((i+3)>=arrF.length || ((i+3)<arrF.length && !Character.isLetterOrDigit(arrF[i+3])))){
								 String code = extractCode(aFunction, i);
								 allCodes.add(id++, code);
								 i+=2;
						}
					}
					else if((i+4)<arrF.length && arrF[i]=='w' && arrF[i+1]=='h' && arrF[i+2]=='i' && arrF[i+3]=='l' && arrF[i+4]=='e'){
						if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(arrF[i-1]))) 
								&& ((i+5)>=arrF.length || ((i+5)<arrF.length && !Character.isLetterOrDigit(arrF[i+5])))){
								 String code = extractCode(aFunction, i);
								 allCodes.add(id++, code);
								 i+=4;
						}
					}
					else if((i+5)<arrF.length && arrF[i]=='s' && arrF[i+1]=='w' && arrF[i+2]=='i' && arrF[i+3]=='t' && arrF[i+4]=='c' && arrF[i+5]=='h'){
						if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(arrF[i-1]))) 
								&& ((i+6)>=arrF.length || ((i+6)<arrF.length && !Character.isLetterOrDigit(arrF[i+6])))){
								 String code = extractCode(aFunction, i);
								 allCodes.add(id++, code);
								 i+=5;
						}
					}
					else if((i+3)<arrF.length && arrF[i]=='c' && arrF[i+1]=='a' && arrF[i+2]=='s' && arrF[i+3]=='e'){
						if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(arrF[i-1]))) 
								&& ((i+4)>=arrF.length || ((i+4)<arrF.length && !Character.isLetterOrDigit(arrF[i+4])))){
								 String code = extractCaseCode(aFunction, i);
								 allCodes.add(id++, code);
								 i+=3;
						}
					}
					else if((i+6)<arrF.length && arrF[i]=='d' && arrF[i+1]=='e' && arrF[i+2]=='f' && arrF[i+3]=='a' && arrF[i+4]=='u' && arrF[i+5]=='l' && arrF[i+6]=='t'){
						if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(arrF[i-1]))) 
								&& ((i+7)>=arrF.length || ((i+7)<arrF.length && !Character.isLetterOrDigit(arrF[i+7])))){
								 String code = extractCaseCode(aFunction, i);
								 allCodes.add(id++, code);
								 i+=6;
						}
					}
					else if((i+1)<arrF.length && arrF[i]=='i' && arrF[i+1]=='f'){
						if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(arrF[i-1]))) 
								&& ((i+2)>=arrF.length || ((i+2)<arrF.length && !Character.isLetterOrDigit(arrF[i+2])))){
								 String code = extractCode(aFunction, i);
								 allCodes.add(id++, code);
								 i+=1;
						}
					}
					else if((i+3)<arrF.length && arrF[i]=='e' && arrF[i+1]=='l' && arrF[i+2]=='s' && arrF[i+3]=='e'){
						if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(arrF[i-1]))) 
								&& ((i+4)>=arrF.length || ((i+4)<arrF.length && !Character.isLetterOrDigit(arrF[i+4])))){
								 String code = extractCode(aFunction, i);
								 allCodes.add(id++, code);
								 i+=3;
						}
					}
				}
			}
			
			else if(flagStrComm!='\0' && (arrF[i] == '\'' || arrF[i] == '\"' ||
					((i+1)< arrF.length && arrF[i] == '*' && arrF[i+1]== '\\') || arrF[i]==  '\n' ) )
			{
				if(( flagStrComm == '\'' && arrF[i] == '\'') || ( flagStrComm == '\"' && arrF[i] == '\"') || ( flagStrComm == '\\' &&  arrF[i]==  '\n')
						|| ( flagStrComm == '*' &&  (i+1)< arrF.length && arrF[i] == '*' && arrF[i+1]== '\\'))
				{
					flagStrComm='\0';
					if(( flagStrComm == '*' &&  (i+1)< arrF.length && arrF[i] == '*' && arrF[i+1]== '\\'))
						i++;
				}
			}
			
			
		}
	}
	
/* ******************************************************** */
	public String extractCode(String str, int start)	{
/* ******************************************************** */
		int brackets = -1;
		int end =0;
	//	int flag=0; //to know if the { is part of our condition or not
		int roundBracket = 0; //what's btw () doesn't matter
		int elseFlag=0; //if else if else else 
		int ifFlag=0;
		
		for (int i = start; i < str.length(); i++) {
			
			if(i==start){
				if((i+3)<str.length() && str.charAt(i)=='e' && str.charAt(i+1)=='l' && str.charAt(i+2)=='s' && str.charAt(i+3)=='e'){
					if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(str.charAt(i-1)))) 
							&& ((i+4)>=str.length() || ((i+4)<str.length() && !Character.isLetterOrDigit(str.charAt(i+4))))){
						int j=i+4;
			        	while(j<str.length() && Character.isWhitespace(str.charAt(j)))
			        		j++;
			        	if((j+1)>=str.length() || str.charAt(j)!='i' || str.charAt(j+1)!='f')
			        		elseFlag=1;
			        	i+=3;
					}
				}
				else if((i+1)<str.length() && str.charAt(i)=='i' && str.charAt(i+1)=='f'){
					ifFlag=1;
					i++;
				}
			}
			
			if((i+1)<str.length() && str.charAt(i)=='i' && str.charAt(i+1)=='f' && ifFlag==1){
				ifFlag=0; //when there's an if inside an if there's no problem so no need to continue w/ checking
			}

			if(str.charAt(i) == '('){
				roundBracket++;
			}
			else if(str.charAt(i) == ')'){
				roundBracket--;
			}
			
			else if(str.charAt(i) == '{') {
				if(brackets == -1)
					brackets=0;
	        	brackets ++;
	        }
	        else if(str.charAt(i) == '}') {
	        	brackets --;
	        }
	        
	        if(brackets == 0 || (brackets == -1 && str.charAt(i) == ';' && roundBracket==0))
	        {
	        	int j=i+1;
	        	while(j<str.length() && Character.isWhitespace(str.charAt(j)))
	        		j++;
	        	
	        	if(ifFlag==1 || elseFlag==1 || (j+3)>=str.length() || ((j+3)<str.length() && (  brackets == -1 )
	        			&& str.charAt(j)!='e'  || str.charAt(j+1)!='l'  || str.charAt(j+2)!='s'  || str.charAt(j+3)!='e')){//flag == 1 ||
	        		end = j-1;
	        		break;
	        	}
	        	else if((j+3)<str.length() && str.charAt(j)=='e' && str.charAt(j+1)=='l' && str.charAt(j+2)=='s' && str.charAt(j+3)=='e'){
	        		j+=4;
		        	while(j<str.length() && Character.isWhitespace(str.charAt(j)))
		        		j++;
		        	if((j+1)>=str.length() || str.charAt(j)!='i' || str.charAt(j+1)!='f')
		        		elseFlag=1;
	        	}
	        }
		}
		
		return str.substring(start, end);
		
	}
	
/* ******************************************************** */
	public String extractCaseCode(String str, int start)	{
/* ******************************************************** */
		int brackets = 0;
		int end =0;
		//int flag=0; //to know if the { is part of our condition or not
		for (int i = start; i < str.length(); i++) {
			
			if(str.charAt(i) == '{') {
	        	brackets ++;
	        }
	        else if(str.charAt(i) == '}') {
	        	brackets --;
	        }
	        
	        if((brackets == -1 && str.charAt(i) == '}') 
	        		|| (brackets == 0 && ( ((i+4)<str.length() && str.charAt(i+1)=='c' && str.charAt(i+2)=='a' && str.charAt(i+3)=='s' && str.charAt(i+4)=='e') 
	        				||  ((i+7)<str.length() && str.charAt(i+1)=='d' && str.charAt(i+2)=='e' && str.charAt(i+3)=='f' && str.charAt(i+4)=='a' && str.charAt(i+5)=='u' && str.charAt(i+6)=='l' && str.charAt(i+7)=='t') )))
	        {
	        		end = i+1;
	        		break;
	        }
		}
		
		return str.substring(start, end);
		
	}
	
/* ******************************************************** */
	public String removeTitle(String str){
/* ******************************************************** */
		int at=0;
		for (int i = 0; i < str.length(); i++) {
	        if (str.charAt(i) == '{') {
	        	at=i+1;
	        	break;
	        }
		}
		return str.substring(at,str.length()-2);
	}

/* ******************************************************** */
	public String emptyRoundBrackets(String str){
/* ******************************************************** */
		int openFlag=0;
		for (int i = 0; i < str.length(); i++) {
	        if (str.charAt(i) == '(') {
		        	openFlag++;
		        	if(openFlag>1)
		        		str = str.substring(0, i) + "x" + str.substring(i+1);
	        }
	        else if (str.charAt(i) == ')') {
	        	openFlag--;
	        	if(openFlag >=1)
	        		str = str.substring(0, i) + "x" + str.substring(i+1);
	        }
	        else if(openFlag>=1){
	        	str = str.substring(0, i) + "x" + str.substring(i+1);
	        }
	    }
		
		return str;
	}

/* ******************************************************** */
	@SuppressWarnings("unchecked")
	public String arrangeElseIf(String str){
/* ******************************************************** */
		int count=0;
		TreeMap<Integer, Integer> hash = new TreeMap<>();
		ArrayList<Integer> used= new ArrayList<Integer>();
		ArrayList<Integer> usedJ= new ArrayList<Integer>();
		ArrayList<Integer> tmp= new ArrayList<Integer>();
		
		do{
			tmp=(ArrayList<Integer>)used.clone();
			for (int i = 4; i < str.length(); i++) {
		        if (str.charAt(i-4)=='m' && str.charAt(i-3)=='i' && str.charAt(i-2)=='x' && str.charAt(i-1)=='e' && str.charAt(i)=='d' 
		        		&& i+2 <= str.length() && !used.contains(i)) {
		        	used.add(i);
		        	count++;
		        	int openBracket=0;
		        	int j=i+2;
		        	for(; j < str.length();j++){
		        		if(str.charAt(j)=='{')
		        			openBracket++;
		        		else if(str.charAt(j)=='}')
		        			openBracket--;
		        		
		        		if(str.charAt(j)=='}' && openBracket==0 && !usedJ.contains(j))
		        		{
		        			usedJ.add(j);
		        			if (j+5 <= str.length() && 
		        					 str.charAt(j+1)=='m' && str.charAt(j+2)=='i' && str.charAt(j+3)=='x' && str.charAt(j+4)=='e' && str.charAt(j+5)=='d')
		        				break;
		        			else if (j+4 <= str.length() && 
		        					 str.charAt(j+1)=='e' && str.charAt(j+2)=='l' && str.charAt(j+3)=='s' && str.charAt(j+4)=='e')
		        				break;
		        			else{
		        				if(!hash.containsKey(j))
		        					hash.put(j, count);
		        				count=0;
		        				break;
		        			}
		        			
		        		}
		        	}
		        	i=j;
		        }
		        else if(count>0 && str.charAt(i-3)=='e' && str.charAt(i-2)=='l' && str.charAt(i-1)=='s' && str.charAt(i)=='e' && i+2 <= str.length()  && !used.contains(i))
		        {
		        	used.add(i);
		        	int openBracket=0;
		        	int j=i+2;
		        	for(; j < str.length();j++){
		        		if(str.charAt(j)=='{')
		        			openBracket++;
		        		else if(str.charAt(j)=='}')
		        			openBracket--;
		        		if(str.charAt(j)=='}' && openBracket==0)
		        		{
		        			if(!hash.containsKey(j))
		        				hash.put(j, count);
		        			count=0;
		        			break;
		        		}
		        		
		        	}
		        	i=j;
		        }
		    }
		}while(tmp.size() !=used.size());
			
		int offset=0;
		
		for(int idx : hash.keySet())
		{
			int val = hash.get(idx);
			idx +=offset;
			offset+=val;
			
			while(val>0){
				str = new StringBuffer(str).insert(idx, "}").toString();
				val--;
			}
		}
	
		
		return str;
	}

	
/* ******************************************************** */
	public String closeCases(String str){
/* ******************************************************** */
		int index=str.indexOf("switch");
		while(index>0){
			int cnt=0;
			for (int i = index; i < str.length(); i++) {
				if(str.charAt(i)=='{'){
					cnt++;
				}
				else if(str.charAt(i)=='}'){
					cnt--;
					if(cnt==0)
					{
						str = new StringBuffer(str).insert(i, "}").toString();
						index=str.indexOf("switch",i);
						break;
					}
				}
			}
		}
		return str;
	}

/* ******************************************************** */
	public String placeBrackets(String str){
/* ******************************************************** */
		ArrayList<Integer> at= new ArrayList<Integer>();
		ArrayList<Integer> openIdx= new ArrayList<Integer>();
		ArrayList<Integer> closeIdx= new ArrayList<Integer>();
		int last=0, atBracket=0, openElse=0;
		at.add(0,0);
		for (int i = 0; i < str.length(); i++) {
		
	        if (str.charAt(i) == '@' && str.charAt(i+1) != '{') {
	        	if(last==0){
		        	openIdx.add(i+openIdx.size()+1);
		        	at.add(atBracket, 1);
		        	last=1;
	        	}
	        	else if(last==1){
	        			openIdx.add(i+openIdx.size()+1);
			        	at.set(atBracket, at.get(atBracket)+1);
		        	}
	        	
	        }
	        else if(str.charAt(i) == '{'){
        		atBracket++;
        		at.add(atBracket, 0);
        		last=0;
        	}
	        else if(str.charAt(i) == ';' && last == 1){
	        	if(((i+4)<= str.length() && (str.charAt(i+1)!='e'  || str.charAt(i+2)!='l'  || str.charAt(i+3)!='s'  || str.charAt(i+4)!='e')) 
	        			|| ((i+4)<= str.length() && str.charAt(i+1)=='e'  && str.charAt(i+2)=='l'  && str.charAt(i+3)=='s'  && str.charAt(i+4)=='e' && openElse==1) 
	        			|| (i+4)>str.length()){
		        	while(at.get(atBracket) > 0){
		        		at.set(atBracket, at.get(atBracket)-1);
		        		closeIdx.add(i+openIdx.size()+closeIdx.size()+1);
		        	}
		        	openElse=0;
		        	last=0;
	        	}
	        	else if((i+4)<= str.length() && str.charAt(i+1)=='e'  && str.charAt(i+2)=='l'  && str.charAt(i+3)=='s'  && str.charAt(i+4)=='e'){
	        		openElse=1;
	        		at.set(atBracket, at.get(atBracket)-1);
	        		closeIdx.add(i+openIdx.size()+closeIdx.size()+1);
	        	}
	        	else{
	        		at.set(atBracket, at.get(atBracket)-1);
	        		closeIdx.add(i+openIdx.size()+closeIdx.size()+1);
	        		openElse=0;//just in case
	        	}
	        }
	        
	        else if(str.charAt(i) == '}'){
	        	if(atBracket > 0)
	        		atBracket--;
	        	while(at.get(atBracket) > 0){
	        		at.set(atBracket, at.get(atBracket)-1);
	        		closeIdx.add(i+openIdx.size()+closeIdx.size()+1);
	        	}
	        	last=0;
	        }
	        
		}
		for (int i : openIdx) {
			str = new StringBuffer(str).insert(i, "{").toString();
		}
		for (int i : closeIdx) {
			str = new StringBuffer(str).insert(i, "}").toString();
		}
		return str;
	}

/* ******************************************************** */
	public String replaceBrackets(String str){
/* ******************************************************** */
		int up=0, down=0;
		ArrayList<Integer> closed= new ArrayList<Integer>();
		for (int i = 0; i < str.length(); i++) {
	        if (str.charAt(i) == '{') {
		        	str = str.substring(0, i) + Integer.toString(up) + "#" + str.substring(i+1);
		        	down=up;
		        	up++;
	        }
	        else if (str.charAt(i) == '}') {
	        	
		        	str = str.substring(0, i) + Integer.toString(down) + "~" + str.substring(i+1);
		        	closed.add(down);
		        	while(closed.contains(down))
		        		down--;
	        }
	    }
		
		return str;
	}

/* ******************************************************** */
	public String getNewFucntion(){
/* ******************************************************** */
		return newFunction;
	}
	
/* ******************************************************** */
	public String getName(){
/* ******************************************************** */
		return name;
	}
	
/* ******************************************************** */
	public String getCode(int id){
/* ******************************************************** */
		return allCodes.get(id);
	}

}



















//if(brackets==-1){
//if((i+2)<str.length() && str.charAt(i)=='f' && str.charAt(i+1)=='o' && str.charAt(i+2)=='r'){
//	if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(str.charAt(i-1)))) 
//			&& ((i+3)>=str.length() || ((i+3)<str.length() && !Character.isLetterOrDigit(str.charAt(i+3))))){
//			flag=1;
//			i+=2;
//			continue;
//	}
//}
//else if((i+4)<str.length() && str.charAt(i)=='w' && str.charAt(i+1)=='h' && str.charAt(i+2)=='i' && str.charAt(i+3)=='l' && str.charAt(i+4)=='e'){
//	if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(str.charAt(i-1)))) 
//			&& ((i+5)>=str.length() || ((i+5)<str.length() && !Character.isLetterOrDigit(str.charAt(i+5))))){
//		flag=1;
//		i+=3;
//		continue;
//	}
//}
//else if((i+5)<str.length() && str.charAt(i)=='s' && str.charAt(i+1)=='w' && str.charAt(i+2)=='i' && str.charAt(i+3)=='t' && str.charAt(i+4)=='c'  && str.charAt(i+5)=='h'){
//	if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(str.charAt(i-1)))) 
//			&& ((i+6)>=str.length() || ((i+6)<str.length() && !Character.isLetterOrDigit(str.charAt(i+6))))){
//		flag=1;
//		i+=6;
//		continue;
//	}
//}
//else if((i+1)<str.length() && str.charAt(i)=='i' && str.charAt(i+1)=='f'){
//	if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(str.charAt(i-1)))) 
//			&& ((i+2)>=str.length() || ((i+2)<str.length() && !Character.isLetterOrDigit(str.charAt(i+2))))){
//		flag=1;
//		i+=1;
//		continue;
//	}
//}
//else if((i+3)<str.length() && str.charAt(i)=='e' && str.charAt(i+1)=='l' && str.charAt(i+2)=='s' && str.charAt(i+3)=='e'){
//	if( ((i-1)<0 || ((i-1)>=0 && !Character.isLetterOrDigit(str.charAt(i-1)))) 
//			&& ((i+4)>=str.length() || ((i+4)<str.length() && !Character.isLetterOrDigit(str.charAt(i+4))))){
//		flag=1;
//		i+=2;
//		continue;
//	}
//}
//}

