package func2graphrenewed;

import java.util.ArrayList;
import org.eclipse.swt.graphics.Color;

public class Node {

	
	/**********************************************************
	 *                       VARIABLES                        *
	 **********************************************************/
	private double x,y;
	private int id,start, size, nodeHeight;
	private String kind,shape,color, code;
	private Color RGBcolor;
	private Node parent;
	private ArrayList<Node> children;
	
	/**********************************************************
	 *                     Constructor                        *
	 **********************************************************/
	public Node(){
		init();
	}
	
	public Node(String kind, int id, String code)
	{
		this.kind=kind;
		this.id=id;
		this.start=0;
		init();
	}
	
	public Node(String kind, Node parent, int start, int id, String code)
	{
		this.kind=kind;
		this.id=id;
		this.parent = parent;
		this.start= start;
		this.code = code;
		init();
		
	}
	
	public void init(){
		this.size=0;
		this.children = new ArrayList<Node>();
		if(kind=="if"){shape="invtrapezium"; color= "gold"; RGBcolor=new Color(null, 255, 224, 54);}
		else if(kind=="else"){shape="invtrapezium";color="orange"; RGBcolor=new Color(null, 232, 140, 41);}

		else if(kind=="for"){shape="invtrapezium";color= "cyan"; RGBcolor=new Color(null, 100, 200 ,200);}
		else if(kind=="while"){shape="invtrapezium";color="green"; RGBcolor=new Color(null, 53, 203, 120);}

		else if(kind=="switch"){shape="trapezium";color="blue"; RGBcolor=new Color(null, 209, 61, 61);}
		else if(kind=="case"){shape="septagon";color="red"; RGBcolor=new Color(null, 93, 90, 161);}
		
		else if(kind=="Gen"){shape="box";color="bisque"; RGBcolor=new Color(null, 225, 217, 172);}
	}
	
	/**********************************************************
	 *                      FUNCTIONS                         *
	 **********************************************************/
	
	public Node getParent(){
		return this.parent;
	}
	
	public boolean hasChild(){
		return !children.isEmpty();
	}
	
	public Node getNextChild(Node lastchild){
		if(lastchild == null)
			return children.get(0);
		
		int idx = children.indexOf(lastchild);
		if(idx+1>=children.size())
			return null;
		
		return children.get(idx+1);
	}
	
	public void setX(){
		this.x = this.start + (double)this.size/2;
	}
	
	public void setX(double x){
		this.x = x;
	}
	
	public void setY(double y){
		this.y = y;
	}
	public double getX(){
		return this.x;
	}
	public double getY(){
		return this.y;
	}
	
	public String getShape(){
		return this.shape;
	}
	public String getColor(){
		return this.color;
	}
	public void addChild(Node node){
		children.add(node);
	}
	
	public void addSize(int size){
		this.size+=size;
	}
	
	public void addSize(double size){
		this.size+=size;
	}
	
	public int getSize(){
		return this.size;
	}
	
	public int getStart(){
		return this.start;
	}
	
	public String getKind(){
		return this.kind;
	}
	
	public int getId(){
		return this.id;
	}
	
	public void setNodeHeight(int height){
		nodeHeight = height;
	}
	public int getNodeHeight(){
		return nodeHeight;
	}
	
	public Color getRGBColor(){
		return this.RGBcolor;
	}
	public String getCode(){
		return code;
	}
}
