package func2graphrenewed;


public class Tree {

	
	/**********************************************************
	 *                       VARIABLES                        *
	 **********************************************************/
	private Node root;
	private int maxLevel, nodeHeight, heightTotal; //heightTotal = height + space
	private String name;
	private Function aFunction;
	
	/**********************************************************
	 *                     Constructor                        *
	 **********************************************************/
	public Tree(Function aFunction, int nodeHeight, int space){
		this.aFunction = aFunction;
		root=buildTree(aFunction.getNewFucntion());
		maxLevel=0;
		this.nodeHeight = nodeHeight; 
		this.heightTotal = nodeHeight + space;
		name = aFunction.getName();
	}
	
	/**********************************************************
	 *                      FUNCTIONS                         *
	 **********************************************************/

/* ******************************************************** */
	public Node buildTree(String aFunction){
/* ******************************************************** */
		String[] lines=aFunction.split("\n");
		Node currentNode = new Node("Gen", 0, this.aFunction.getCode(0));
		int size=0, id=1;
		for(int i=0; i<lines.length;i++){
			if(!lines[i].contains("#") && !lines[i].contains("~")){
				size++;
			}
		
			else if(lines[i].contains("#")){
				currentNode.addSize(size);
				int start = currentNode.getStart() + currentNode.getSize();
				Node tmp= createNode(lines[i], currentNode, start, id, this.aFunction.getCode(id));
				currentNode.addChild(tmp);
				currentNode = tmp;
				size=0; id++;
			}
			
			else if(lines[i].contains("~")){
				currentNode.addSize(size);
				currentNode.setX();
				int tmpSize = currentNode.getSize();
				currentNode = currentNode.getParent();
				currentNode.addSize(tmpSize);
				size=0;
			}
		}
		
		currentNode.addSize(size);	
		return currentNode;
	}
	
/* ******************************************************** */
	public Node createNode(String str,Node parent, int start, int idx,String code)	{
/* ******************************************************** */
		
			Node node=null;
			
			if (str.contains("if")) 
				node = new Node("if", parent, start, idx, code);
			else if (str.contains("else")) 
				node = new Node("else", parent, start, idx, code);
			else if (str.contains("for"))
				node = new Node("for", parent, start, idx, code);
			else if (str.contains("while"))
				node = new Node("while", parent, start, idx, code);
			else if (str.contains("switch"))
				node = new Node("switch", parent, start, idx, code);
			else if (str.contains("case"))
				node = new Node("case", parent, start, idx, code);
		
			return node;
		}
	
/* ******************************************************** */
	public void setPosition(){
/* ******************************************************** */
		//maxLevel = (calcMaxLevel(root) + 1);
		maxLevel = (calcMaxLevel(root) + 1) * (heightTotal); // # of levels x (node height + space btw nodes)
		//root.setY(maxLevel - (nodeHeight/2));
		root.setY(0); // Lets room for the legend
		root.setX();
		root.setNodeHeight(nodeHeight);
		setXY(root,  nodeHeight + 2*heightTotal);
		
	}

/* ******************************************************** */
	public void setXY(Node root, int level){
/* ******************************************************** */
		if(!root.hasChild())
			return;
		
		Node currentChild= null;
		while(root.getNextChild(currentChild) != null){
			currentChild = root.getNextChild(currentChild);
			//currentChild.setY(maxLevel - (nodeHeight/2));
			currentChild.setNodeHeight(nodeHeight);
			currentChild.setY(level);
			setXY(currentChild,level + heightTotal);
		}
		
	}

/* ******************************************************** */
	public int calcMaxLevel(Node root){
/* ******************************************************** */
		if(!root.hasChild())
			return 0;
		
		Node currentChild = null;
		int max=0;
		while(root.getNextChild(currentChild) != null){
			if(currentChild ==null)
				max=0;
			currentChild = root.getNextChild(currentChild);
			int ret = calcMaxLevel(currentChild)+1;
			if(ret>max)
				max=ret;
		}
			return max;
	}

/* ******************************************************** */
	public int getMaxLevel(){
/* ******************************************************** */
		return maxLevel;
	}

/* ******************************************************** */	
	public Node getRoot(){
/* ******************************************************** */
		return root;
	}
	
/* ******************************************************** */	
	public Node getNode(Node root, int id){
/* ******************************************************** */
		if(root.getId()==id)
			return root;
		
		if(!root.hasChild())
			return null;
		
		Node currentChild = null;
		Node ret = null;
		while(root.getNextChild(currentChild) != null){
			currentChild = root.getNextChild(currentChild);
			ret = getNode(currentChild, id);
			if(ret!=null)
				return ret;
		}
		return ret;
	}
	
/* ******************************************************** */
	public int getNodeHeight(){
/* ******************************************************** */
		return nodeHeight;
	}
	
/* ******************************************************** */
	public String getName(){
/* ******************************************************** */
		return name;
	}
}
